
require "import"
import "android.os.*"
import "android.widget.*"
import "android.view.*"
import "net.fusionapp.core.ui.fragment.WebInterface"
import "com.google.android.material.card.MaterialCardView"
import "android.content.Intent"
import "net.fusionapp.core.util.FusionUtil"
import "android.widget.Toast"
import "android.widget.TextView"
import "android.widget.LinearLayout"
import "android.net.Uri"

--local intent=activity.getIntent()

--获取到主页面传递过来的url
local url=...
--获取界面管理器
uiManager=activity.getUiManager()
--获取浏览器控件
webView=uiManager.getCurrentFragment().getWebView()

--加载链接
function 加载链接(url)
  webView.loadUrl(url)
end

function urlDecode(s)
  s=s:gsub("+"," "):gsub('%%(%x%x)',function(h) return string.char(tonumber(h,16)) end)
  return s
end

--设置浏览器监听
local uimanager=activity.uiManager
local fragment=uimanager.currentFragment
fragment.setWebInterface(WebInterface{
  onPageFinished=function(view,url)
    --页面加载结束事件
  end,
  onPageStarted=function(view,u,favicon)
    if urlDecode(u)==url then
      webView.clearHistory()
    end
  end,
  onReceivedTitle=function(view,title)
    --获取到网页标题时设置顶栏标题
    uiManager.getToolbar().titleText=title
  end,
  onLoadResource=function(view,url)
    --页面资源加载监听
    --可通过该方法获取网页上的资源
  end,
  onUrlLoad=function(view,url)
    --即将开始加载事件，url参数是即将加载的url
    --该函数返回一个布尔值
    --返回true则拦截本次加载
    return false
  end
})

加载链接(url)

FusionUtil=luajava.bindClass "net.fusionapp.core.util.FusionUtil"
android_R=luajava.bindClass "android.R"
menus=activity.viewConfig.toolbar.getMenus()

function recreate()
  activity.finish()
  activity.startFusionActivity(activity.loader.pageName)
  activity.overridePendingTransition(android_R.anim.fade_in,android_R.anim.fade_out)
end
function switchNightTheme(isNightMode,newThemeName)
  if isNightMode then
    menus[1].setIcon("wb_sunny")--图片1
   else
    menus[1].setIcon("brightness_2")--图片2
  end
  activity.loader.updatePageConfig()
  FusionUtil.changeTheme(activity.loader.projectDir.path,newThemeName)
  FusionUtil.setNightMode(isNightMode)
  recreate()
end

function onMenuItemClick(title)
  local itemTitle = title
  if itemTitle=="复制链接"then
    获取浏览器()
    复制文本(获取网址())
    print("已复制链接")
  end
  if itemTitle=="刷新"then
    刷新网页()
    print("刷新网页")
  end
  --夜间模式
  if itemTitle=="夜间模式"then
    if menus[1].getIcon()=="brightness_2" then
      switchNightTheme(true,"Night.json")
      print("夜间模式")
     else
      switchNightTheme(false,"Default_Light.json")
      print("日间模式")
    end
  end
  if itemTitle=="在浏览器打开"then
    import "android.content.Intent"
    import "android.net.Uri"
    url=(获取浏览器().url)
    viewIntent = Intent("android.intent.action.VIEW",Uri.parse(url))
    activity.startActivity(viewIntent)
  end

end






--全局下载跳转浏览器--每个带有下载能力的子页面都要放置
local uiManager=activity.uiManager

function webviewRefresh(index)
  uiManager.getFragment(index).webView.setDownloadListener{
    onDownloadStart=function(url,a,b,c,d)
      activity.startActivity(Intent("android.intent.action.VIEW",Uri.parse(url)))
    end
  }
end
webviewRefresh(0)
uiManager.viewPager.setOnPageChangeListener(luajava.bindClass "androidx.viewpager.widget.ViewPager$OnPageChangeListener"{
  onPageSelected=function(index)
    webviewRefresh(index)
  end
})





